unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, SCANNERLib_TLB;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    cboimagesource: TComboBox;
    Label2: TLabel;
    cbopixeltype: TComboBox;
    cbodpi: TComboBox;
    Label3: TLabel;
    chkshowui: TCheckBox;
    chkclearimage: TCheckBox;
    chkenablefeeder: TCheckBox;
    chkenableduplex: TCheckBox;
    GroupBox2: TGroupBox;
    chkdefaultcap: TCheckBox;
    Label1: TLabel;
    txtcapleft: TEdit;
    Label4: TLabel;
    txtcaptop: TEdit;
    Label5: TLabel;
    txtcapwidth: TEdit;
    Label6: TLabel;
    txtcapheight: TEdit;
    Label7: TLabel;
    Button1: TButton;
    Button3: TButton;
    Label8: TLabel;
    lblcurrentpage: TLabel;
    Label9: TLabel;
    lbltotalpage: TLabel;
    Label10: TLabel;
    txtpageno: TEdit;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    GroupBox4: TGroupBox;
    Button2: TButton;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    optmode1: TRadioButton;
    optmode2: TRadioButton;
    optmode3: TRadioButton;
    GroupBox7: TGroupBox;
    optfilter1: TRadioButton;
    optfilter2: TRadioButton;
    optfilter3: TRadioButton;
    optfilter4: TRadioButton;
    GroupBox8: TGroupBox;
    optlang1: TRadioButton;
    optlang2: TRadioButton;
    optlang3: TRadioButton;
    optlang4: TRadioButton;
    optlang5: TRadioButton;
    optlang6: TRadioButton;
    optlang7: TRadioButton;
    GroupBox9: TGroupBox;
    chkfullpage: TCheckBox;
    Label11: TLabel;
    txtocrleft: TEdit;
    Label12: TLabel;
    txtocrtop: TEdit;
    Label15: TLabel;
    txtocrwidth: TEdit;
    Label16: TLabel;
    txtocrheight: TEdit;
    Label17: TLabel;
    Scanner1: TScanner;
    SaveDialog1: TSaveDialog;
    RadioOutput1: TRadioButton;
    RadioOutput2: TRadioButton;
    GroupBox3: TGroupBox;
    Label13: TLabel;
    txttotalchar: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Scanner1EndScan(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure chkfullpageClick(Sender: TObject);
    procedure Scanner1OCRRecognized(ASender: TObject; bSuccess: WordBool);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin

  if RadioButton1.Checked then
    scanner1.SelectImageSourceByIndex(cboimagesource.ItemIndex)
  else
      begin
          if scanner1.SelectImageSource <> true then
              exit;

      end;

  if chkshowui.Checked then
    scanner1.ShowTwainUI:=true
  else
    scanner1.ShowTwainUI:=false;

  if chkclearimage.Checked then
    scanner1.ClearImageBuffer:=true
  else
    scanner1.ClearImageBuffer:=false;


  if chkenableduplex.Checked then
    scanner1.DuplexEnabled:=true
  else
    scanner1.DuplexEnabled:=false;

  if chkenablefeeder.Checked then
    scanner1.FeederEnabled:=true
  else
    scanner1.FeederEnabled:=false;


    case cbodpi.ItemIndex of
                0: scanner1.DPI:=96;
                1: scanner1.DPI:=200;
                2: scanner1.DPI:=300;
                3: scanner1.DPI:=600;
    end;


    case cbopixeltype.ItemIndex of
                0: scanner1.PixelType:=-1;
                1: scanner1.PixelType:=0;
                2: scanner1.PixelType:=1;
                3: scanner1.PixelType:=2;
    end;


     if chkdefaultcap.Checked then
            scanner1.SetCaptureArea(0,0,0,0)
     else
            scanner1.SetCaptureArea(strtofloat(txtcapleft.text),strtofloat(txtcaptop.text),strtofloat(txtcapwidth.text),strtofloat(txtcapheight.text) );


 //   scanner1.DPI:= strtoint(cbodpi.Items[cbodpi.ItemIndex]);

scanner1.Scan;


end;

procedure TForm1.Button2Click(Sender: TObject);
var iresult : Integer ;
var iLangindex : Integer;
var FontID : Integer ;
var FontID2 : Integer ;
var iMode :Integer;
begin

   iLangindex:=0;
   iMode:=0;

   scanner1.View:=5;
  
   if optmode1.Checked then
      iMode:=0;

   if optmode2.Checked then
      iMode:=1;

   if optmode3.Checked then
      iMode:=2;

   if optfilter1.Checked then
      Scanner1.OCRCharFilter :='';

   if optfilter2.Checked then
      Scanner1.OCRCharFilter :='0123456789';

   if optfilter3.Checked then
      Scanner1.OCRCharFilter :='ABCDEFGHIJKLMNOPQRSTUVWXYZ';

   if optfilter4.Checked then
      Scanner1.OCRCharFilter :='abcdefghijklmnopqrstuvwxyz';



   if optlang1.Checked then
      iLangindex:=0;

   if optlang2.Checked then
      iLangindex:=1;

   if optlang3.Checked then
      iLangindex:=2;

   if optlang4.Checked then
      iLangindex:=3;

   if optlang5.Checked then
      iLangindex:=4;

   if optlang6.Checked then
      iLangindex:=5;

   if optlang7.Checked then
      iLangindex:=6;

   //ocr setting

   Scanner1.OCRRecognizeMode := iMode;

    If chkfullpage.Checked Then
       Scanner1.OCRSetRect (0, 0, 0, 0)
    else
      Scanner1.OCRSetRect( strtoint(txtocrleft.text), strtoint(txtocrtop.text), strtoint(txtocrwidth.text), strtoint(txtocrheight.text));



    iresult :=Scanner1.OCRStartScan(iLangIndex, 'dictfiles');

  

   end;

procedure TForm1.FormActivate(Sender: TObject);
 var
 iCount: Integer;
 i : Integer;
begin



cbodpi.Items.Add('Onscreen Viewing 96dpi');
cbodpi.Items.Add('Fax 200dpi');
cbodpi.Items.Add('OCR Text 300dpi');
cbodpi.Items.Add('Laser Print Fine 600dpi');
cbodpi.ItemIndex:=0;


cbopixeltype.Items.Add('Default');
cbopixeltype.Items.Add('Gray Color');
cbopixeltype.Items.Add('Black & White Color');
cbopixeltype.Items.Add('True Color');
cbopixeltype.ItemIndex:=0;

iCount :=scanner1.GetNumImageSources();

for i := 0 To iCount-1 do
   begin
       cboimagesource.Items.Add(scanner1.GetImageSourceName(i));
   end;

   if  cboimagesource.Items.Count > 0 then
          cboimagesource.ItemIndex:=0;



end;



procedure TForm1.Button3Click(Sender: TObject);
begin
  scanner1.Rotate90();
end;

procedure TForm1.Scanner1EndScan(Sender: TObject);
begin
      lbltotalpage.Caption := Format('%d', [Scanner1.TotalPage] );
     lblcurrentpage.Caption := Format('%d', [Scanner1.GetActivePageNo] );
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
      scanner1.SetActivePageNo(strtoint(txtpageno.text));
      lblcurrentpage.Caption :=  Format('%d', [Scanner1.GetActivePageNo] );
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Scanner1.DeletePage (Scanner1.GetActivePageNo);
  Scanner1.SetActivePageNo (1);
  lbltotalpage.Caption := Format('%d', [Scanner1.TotalPage] );
  lblcurrentpage.Caption := Format('%d', [Scanner1.GetActivePageNo] );



end;

procedure TForm1.Button6Click(Sender: TObject);
begin
Scanner1.ApplyChange;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Scanner1.Rotate180;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  scanner1.Rotate270();
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
    Scanner1.View := 1;
    Scanner1.SetFocus;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  Scanner1.View := 2;
  Scanner1.SetFocus;

end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  Scanner1.View := 3;
  Scanner1.SetFocus;

end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  Scanner1.View := 4;
  Scanner1.SetFocus;

end;

procedure TForm1.Button13Click(Sender: TObject);
begin
  Scanner1.View := 5;
  Scanner1.SetFocus;


end;

procedure TForm1.Button14Click(Sender: TObject);
begin
    Scanner1.View := 6;
    Scanner1.SetFocus;

end;

procedure TForm1.Button15Click(Sender: TObject);
begin
    Scanner1.View := 7;
    Scanner1.SetFocus;

end;

procedure TForm1.Button16Click(Sender: TObject);
begin
    Scanner1.View := 9;
  Scanner1.SetFocus;

end;

procedure TForm1.Button17Click(Sender: TObject);
begin
    Scanner1.View := 10;
    Scanner1.SetFocus;

end;

procedure TForm1.Button19Click(Sender: TObject);
var iresult : bool ;
begin
  

end;

procedure TForm1.chkfullpageClick(Sender: TObject);
begin
    if chkfullpage.Checked then
      begin
       txtocrleft.Enabled:=false;
       txtocrtop.Enabled:=false;
       txtocrwidth.Enabled:=false;
       txtocrheight.Enabled:=false;

     end
    else
       begin
       txtocrleft.Enabled:=true;
       txtocrtop.Enabled:=true;
       txtocrwidth.Enabled:=true;
       txtocrheight.Enabled:=true;


       end;
end;

procedure TForm1.Scanner1OCRRecognized(ASender: TObject;
  bSuccess: WordBool);

var bResult :Bool;
begin

  if bSuccess  then
  begin

  txttotalchar.Text := Format('%d', [Scanner1.OCRGetRecognizedCharCount] ) ;

     if RadioOutput1.Checked then
                 ShowMessage(Scanner1.OCRGetRecognizedText);


             // SaveDialog1.Filter :='PDF File|*.pdf';
  // SaveDialog1.DefaultExt :='pdf';

    // if SaveDialog1.Execute then
     // Scanner1.OCR2SearchableMultipagePDF(SaveDialog1.FileName,iLangIndex, 'dictfiles');


      if RadioOutput2.Checked then
      begin
         SaveDialog1.Filter :='Text Files (*.txt)|*.txt';
         SaveDialog1.DefaultExt :='txt';
                    if SaveDialog1.Execute then
                    begin
                     bResult:=Scanner1.OCRSaveRecognizedText(SaveDialog1.FileName);
                              if bResult then
                                      ShowMessage('Save completed');

      end;          end;
  end;
  

end;

end.
